#pragma once
#include "Std.h"
enum EnemyActionPatternType{
	EAPT_Unknown,

	EAPT_Move,
	EAPT_Standby,
	EAPT_Guided,
	EAPT_Kill
};
class IEnemyActionPattern{
public:
	virtual ~IEnemyActionPattern(){};
	virtual EnemyActionPatternType VGetType() const = 0;
	virtual void VSetType( EnemyActionPatternType type ) = 0;
	virtual void VOnUpdate( IActor* enemy) = 0;
	virtual bool VIsEnd() const = 0;
};
class EnemyActionPattern : public IEnemyActionPattern{
protected:
	EnemyActionPatternType mType;
	bool mIsEndless;//IȂ
	int mEndTime;//̍sIԂ̎
public:
	EnemyActionPattern() : mType( EAPT_Unknown ) , mIsEndless( false ) , mEndTime( 0 ){};
	virtual void VSetType( EnemyActionPatternType type ){ mType = type; }
	virtual bool VIsEnd() const{ return ( mEndTime <= 0 && mIsEndless == false ) ? true : false; }

	virtual EnemyActionPatternType VGetType() const{ return mType; }
};
//ړ ԁAxApx
class EA_Move : public EnemyActionPattern{
private:
	int mSpeed;
	float mAngle;
public:
	EA_Move( int time , int speed , int angle , bool endless = false );
	virtual void VOnUpdate( IActor* enemy);
};
//ҋ@
class EA_Standby : public EnemyActionPattern{
public:
	EA_Standby( int time , bool endless = false );
	virtual void VOnUpdate( IActor* enemy);
};
//U
class EA_Guided : public EnemyActionPattern{
public:
	EA_Guided( int time , int speed , bool endless = false );
	virtual void VOnUpdate( IActor* enemy);
};
//
class EA_Kill : public EnemyActionPattern{
public:
	EA_Kill();
	virtual void VOnUpdate( IActor* enemy);
};
