#include "CSVLoader.h"
#include <fstream>
#include <boost/tokenizer.hpp>
#include <boost/lexical_cast.hpp>
namespace FTLib{
	namespace Common{
		CSVLoader::CSVLoader(){
		}
		CSVLoader::CSVLoader( const char* name ){
			init( name );
		}
		void CSVLoader::init( const char* name ){
			std::ifstream ifs;
			ifs.open( name );
			if( ifs.fail() ) return;
			std::string bufline;
			while( true ){
				std::getline( ifs , bufline );
				if( ifs.fail() || ifs.eof() ) break;
				if( bufline[ 0 ] == '#' ) continue;
				typedef boost::char_separator< char > char_separator;
				typedef boost::tokenizer< char_separator > Tokenizer;
				char_separator sep( "," );
				Tokenizer tok( bufline , sep );
				std::vector< std::string > line;
				Tokenizer::iterator it;

				for( Tokenizer::iterator it = tok.begin() ; it != tok.end() ; ++it ){
					std::string str = *it;
					line.push_back( *it );
				}
				mData.push_back( line );
			}
		}
		std::string CSVLoader::strData( int x , int y ) const{
			if( y >= 0 && y < mData.size() ){
				if( x >= 0 && x < mData[ y ].size() ){
					return mData[ y ][ x ];
				}
			}
			return "";
		}
		int CSVLoader::intData( int x , int y ) const{
			std::string str = strData( x , y );
			try{
				int ret = boost::lexical_cast< int >( str );
				return ret;
			}catch( boost::bad_lexical_cast bad ){
				return 0;
			}
		}
		bool CSVLoader::boolData( int x , int y ) const{
			std::string str = strData( x , y );
			if( str == "TRUE" ){
				return true;
			}else{
				return false;
			}
		}
		int CSVLoader::allLine() const{
			return mData.size();
		}
	}
}