#pragma once
#include <DxLib.h>
namespace FTLib{
	namespace Draw{
		namespace Math{
			typedef DxLib::VECTOR Vector;
			namespace Collision2D{
				struct IShape{
				};
				struct Bar : public IShape{
					Vector start;
					Vector end;
					Bar( Vector& start , Vector& end ) :
					start( start ),
					end( end ){
					}
					Bar(){}
				};
				struct Triangle : public IShape{
					Vector pos1 , pos2 , pos3;
					Triangle( Vector& pos1 , Vector& pos2 , Vector& pos3 ) :
					pos1( pos1 ),
					pos2( pos2 ),
					pos3( pos3 ){
					}
					Triangle(){}
				};
				struct Box : public IShape{
					Vector lefttop;
					Vector leftbottom;
					Vector righttop;
					Vector rightbottom;
					Box(){}
					void draw_d() const{
						DrawBox(
							( int )lefttop.x,
							( int )lefttop.y,
							( int )rightbottom.x,
							( int )rightbottom.y,
							GetColor( 60 , 100 , 200 ),
							0 );
					}
					void draw_d( Vector& pos ) const{
						DrawBox(
							( int )( lefttop.x + pos.x ),
							( int )( lefttop.y + pos.y ),
							( int )( rightbottom.x + pos.x ),
							( int )( rightbottom.y + pos.y ),
							GetColor( 60 , 100 , 200 ),
							0 );
					}
				};
				struct Circle : public IShape{
					Vector pos;
					float r;
				};
				bool barToBar(
					Vector& bar1Start,
					Vector& bar1End,
					Vector& bar2Start,
					Vector& bar2End );
				bool circleToCircle(
					Vector& pos1,
					float r1,
					Vector& pos2,
					float r2 );
				bool triangleToDot( Triangle& triangle , Vector& dotPos );
				bool triangleToTriangle( Triangle& tri1 , Triangle& tri2 );
				bool boxToBox( Box& box1 , Box& box2 );
				bool boxToBox_ZtoX( Box& box1 , Box& box2 );
				bool boxToTriangle( Box& box , Triangle& triangle );
			}
		}
	}
}