#include "CpuImage.h"
#include "Image.h"
#include <DxLib.h>
namespace FTLib{
	namespace Draw{
		CpuImage::CpuImage( const char* filename ){
			mHandle = LoadSoftImage( filename );
			GetSoftImageSize( mHandle , &mWidth , &mHeight );
		}
		CpuImage::~CpuImage(){
			DeleteSoftImage( mHandle );
		}
		int CpuImage::width(){
			return mWidth;
		}
		int CpuImage::height(){
			return mHeight;
		}
		Common::Color CpuImage::getPixelColor( int x , int y ){
			Common::Color color;
			GetPixelSoftImage( mHandle , x , y , &color.red , &color.green , &color.blue , &color.alpha );
			return color;
		}
		Image* CpuImage::createImage(){
			return new Image( mHandle );
		}
	}
}