#include "Display.h"
#include "Camera.h"
#include "resource.h"
#include <DxLib.h>
namespace FTLib{
	namespace Draw{
		bool Display::messageProc(){
			return ProcessMessage() == 0 ? true : false;
		}
		void Display::drawBegin(){
			ClearDrawScreen();
			SetDrawBright( mBrightRed , mBrightGreen , mBrightBlue );
		}
		void Display::drawEnd(){
			ScreenFlip();
			Camera::instance()->app();
			mFrameManage();
		}
		void Display::setFrameNum( int frame ){
			mOneFrameTime = frame / 1000;
		}
		void Display::setDrawBright( int red , int green , int blue ){
			mBrightRed = red;
			mBrightGreen = green;
			mBrightBlue = blue;
		}

		void Display::create(){
			if( !mInstance ){
				mInstance = new Display();
			}
		}
		void Display::destroy(){
			if( mInstance ){
				Camera::destroy();
				DxLib_End();
				delete mInstance;
			}
		}
		Display* Display::instance(){
			return mInstance;
		}

		Display::Display() : mOneFrameTime( 16 ){
				mFrameData = new boost::circular_buffer< int >( MAX_FRAME_DATA );
				SetWindowIconID( IDI_ICON2 );
				Camera::create();
				mBrightRed = 255;
				mBrightGreen = 255;
				mBrightBlue = 255;
				SetWindowText( GAME_TITLE );
				ChangeWindowMode( TRUE );
				SetGraphMode( WIDTH , HEIGHT , 32 );
				SetUse3DFlag( TRUE );
				SetOutApplicationLogValidFlag( FALSE );
				DxLib_Init();
				SetDrawScreen( DX_SCREEN_BACK );
		}
		Display::~Display(){
			delete mFrameData;
		}
		void Display::mFrameManage(){
			if( mFrameData->size() == 0 ){
				mFrameData->push_front( GetNowCount() );
				return;
			}
			int thisTime = GetNowCount();
			int thisFrameTime = thisTime - mFrameData->at( 0 );
			if( mOneFrameTime > thisFrameTime ){
				Sleep( mOneFrameTime - thisFrameTime );
			}
			mFrameData->push_front( thisTime );
		}
		Display* Display::mInstance = 0;
	}
}