#pragma once
#include <boost/circular_buffer.hpp>
#define GAME_TITLE "ACX"
namespace FTLib{
	namespace Draw{
		class Display{
		public:
			bool messageProc();
			void drawBegin();
			void drawEnd();
			void setFrameNum( int frame );//1bԂ̃t[Zbg
			void setDrawBright( int red , int green , int blue );

			static void create();
			static void destroy();
			static Display* instance();
		private:
			Display();
			~Display();

			void mFrameManage();

			int mOneFrameTime;
			boost::circular_buffer< int >* mFrameData;

			int mBrightRed;
			int mBrightGreen;
			int mBrightBlue;

			static Display* mInstance;

			static const int WIDTH = 800;
			static const int HEIGHT = 600;
			static const int MAX_FRAME_DATA = 10;
		};
	}
}