#include "Image.h"
#include <DxLib.h>
namespace FTLib{
	namespace Draw{
		Image::Image( const char* filename ){
			mHandle = LoadGraph( filename );
			GetGraphSize( mHandle , &mWidth , &mHeight );
		}
		Image::Image( int softHandle ){
			mHandle = CreateGraphFromSoftImage( softHandle );
			GetGraphSize( mHandle , &mWidth , &mHeight );
		}
		Image::~Image(){
			DeleteGraph( mHandle );
		}

		int Image::width() const {
			return mWidth;
		}
		int Image::height() const {
			return mHeight;
		}
		void Image::draw( int x , int y ) const {
			DrawGraph( x , y , mHandle , TRUE );
		}
		void Image::draw(
			int x,
			int y,
			int width,
			int height ) const{
				DrawExtendGraph(
					x,
					y,
					x + width,
					y + height,
					mHandle,
					TRUE );
		}
		void Image::rectDraw(
			int x,
			int y,	
			int sorceX,
			int sorceY,
			int sorceWidth,
			int sorceHeight ) const{
				DrawRectGraph(
					x,
					y,
					sorceX,
					sorceY,
					sorceWidth,
					sorceHeight,
					mHandle,
					TRUE,
					FALSE );
		}
		void Image::rotateDraw(
			int centerX,
			int centerY,
			float angle ) const
		{
			DrawRotaGraph(
				centerX,
				centerY,
				1.0,
				static_cast< double >( angle ),
				mHandle,
				1 );
		}
		void Image::rotateDraw(
				int centerX,
				int centerY,
				float angle,
				float size ) const{
					DrawRotaGraph(
						centerX,
						centerY,
						size,
						angle,
						mHandle,
						1 );
		}
		void Image::drawBillboard( float x , float y , float z ){
			DrawBillboard3D(
				VGet( x , y , z ),
				0.5f,
				0.5f,
				mWidth,
				0.0f,
				mHandle,
				TRUE );
		}
		void Image::drawBillboard(
			float x,
			float y,
			float z,
			int width,
			int height ){
				DrawBillboard3D(
					VGet( x , y , z ),
					0.5f,
					0.5f,
					mWidth,
					0.0f,
					mHandle,
					TRUE );
		}
	}
}