#include "Mesh.h"
namespace FTLib{
	namespace Draw{
		Mesh::Mesh( const char* filename ){
			mHandle = MV1LoadModel( filename );
		}
		Mesh::Mesh( Mesh* mesh ){
			mHandle = MV1DuplicateModel( mesh->handle() );
		}
		Mesh::~Mesh(){
			MV1DeleteModel( mHandle );
		}
		void Mesh::draw(){
			MV1DrawModel( mHandle );
		}
		void Mesh::draw( Matrix mat ){
		}
		void Mesh::setPosition( Vector pos ){
			MV1SetPosition( mHandle , pos );
		}
		void Mesh::setScale( Vector scale ){
			MV1SetScale( mHandle , scale );
		}
		void Mesh::setRotate( Vector rotate ){
			MV1SetRotationXYZ( mHandle , rotate );
		}
		void Mesh::setMatrix( Matrix mat ){
			MV1SetMatrix( mHandle , mat );
		}
		//Aj[V
		MeshAnimeData Mesh::setAnime( int animeIndex ){
			MeshAnimeData data;
			data.handle = MV1AttachAnim( mHandle , animeIndex );
			return data;
		}
		void Mesh::setAnimeTime( MeshAnimeData& data , float time ){
			MV1SetAttachAnimTime( mHandle , data.handle , time );
		}
		int Mesh::getAllAnimeTime( MeshAnimeData& data ){
			return MV1GetAttachAnimTime( mHandle , data.handle );
		}
		int Mesh::handle() const{
			return mHandle;
		}
	}
}