#pragma once
#include <DxLib.h>
#include <boost/circular_buffer.hpp>
namespace FTLib{
	namespace Input{
		class Keyboard{
		public:
			enum Key{
				KEY_BACK = KEY_INPUT_BACK,
				KEY_TAB = KEY_INPUT_TAB,
				KEY_ENTER = KEY_INPUT_RETURN,
				KEY_LSHIFT = KEY_INPUT_LSHIFT,
				KEY_RSHIFT = KEY_INPUT_RSHIFT,
				KEY_LCTRL = KEY_INPUT_LCONTROL,
				KEY_RCTRL = KEY_INPUT_RCONTROL,
				KEY_ESC = KEY_INPUT_ESCAPE,
				KEY_SPACE = KEY_INPUT_SPACE,
				KEY_PGUP = KEY_INPUT_PGUP,
				KEY_PGDOWN = KEY_INPUT_PGDN,
				KEY_END = KEY_INPUT_END,
				KEY_HOME = KEY_INPUT_HOME,
				KEY_LEFT = KEY_INPUT_LEFT,
				KEY_UP = KEY_INPUT_UP,
				KEY_RIGHT = KEY_INPUT_RIGHT,
				KEY_DOWN = KEY_INPUT_DOWN,
				KEY_INSERT = KEY_INPUT_INSERT,
				KEY_DELETE = KEY_INPUT_DELETE,
				KEY_MINUS = KEY_INPUT_MINUS,
				KEY_YEN = KEY_INPUT_YEN,
				KEY_PREVTRACK = KEY_INPUT_PREVTRACK,
				KEY_PERIOD = KEY_INPUT_PERIOD,
				KEY_SLASH = KEY_INPUT_SLASH,
				KEY_LALT = KEY_INPUT_LALT,
				KEY_RALT = KEY_INPUT_RALT,
				KEY_SCROLL = KEY_INPUT_SCROLL,
				KEY_SEMICOLON = KEY_INPUT_SEMICOLON,
				KEY_COLON = KEY_INPUT_COLON,
				KEY_LBRACKET = KEY_INPUT_LBRACKET,
				KEY_RBRACKET = KEY_INPUT_RBRACKET,
				KEY_COMMA = KEY_INPUT_COMMA,
				KEY_CAPSLOCK = KEY_INPUT_CAPSLOCK,
				KEY_PAUSE = KEY_INPUT_PAUSE,
				KEY_NUMPAD0 = KEY_INPUT_NUMPAD0,
				KEY_NUMPAD1 = KEY_INPUT_NUMPAD1,
				KEY_NUMPAD2 = KEY_INPUT_NUMPAD2,
				KEY_NUMPAD3 = KEY_INPUT_NUMPAD3,
				KEY_NUMPAD4 = KEY_INPUT_NUMPAD4,
				KEY_NUMPAD5 = KEY_INPUT_NUMPAD5,
				KEY_NUMPAD6 = KEY_INPUT_NUMPAD6,
				KEY_NUMPAD7 = KEY_INPUT_NUMPAD7,
				KEY_NUMPAD8 = KEY_INPUT_NUMPAD8,
				KEY_NUMPAD9 = KEY_INPUT_NUMPAD9,
				KEY_MULTIPLY = KEY_INPUT_MULTIPLY,
				KEY_ADD = KEY_INPUT_ADD,
				KEY_SUBTRACT = KEY_INPUT_SUBTRACT,
				KEY_DECIMAL = KEY_INPUT_DECIMAL,
				KEY_DIVIDE = KEY_INPUT_DIVIDE,
				KEY_F1 = KEY_INPUT_F1,
				KEY_F2 = KEY_INPUT_F2,
				KEY_F3 = KEY_INPUT_F3,
				KEY_F4 = KEY_INPUT_F4,
				KEY_F5 = KEY_INPUT_F5,
				KEY_F6 = KEY_INPUT_F6,
				KEY_F7 = KEY_INPUT_F7,
				KEY_F8 = KEY_INPUT_F8,
				KEY_F9 = KEY_INPUT_F9,
				KEY_F10 = KEY_INPUT_F10,
				KEY_F11 = KEY_INPUT_F11,
				KEY_F12 = KEY_INPUT_F12,
				KEY_A = KEY_INPUT_A,
				KEY_B = KEY_INPUT_B,
				KEY_C = KEY_INPUT_C,
				KEY_D = KEY_INPUT_D,
				KEY_E = KEY_INPUT_E,
				KEY_F = KEY_INPUT_F,
				KEY_G = KEY_INPUT_G,
				KEY_H = KEY_INPUT_H,
				KEY_I = KEY_INPUT_I,
				KEY_J = KEY_INPUT_J,
				KEY_K = KEY_INPUT_K,
				KEY_L = KEY_INPUT_L,
				KEY_M = KEY_INPUT_M,
				KEY_N = KEY_INPUT_N,
				KEY_O = KEY_INPUT_O,
				KEY_P = KEY_INPUT_P,
				KEY_Q = KEY_INPUT_Q,
				KEY_R = KEY_INPUT_R,
				KEY_S = KEY_INPUT_S,
				KEY_T = KEY_INPUT_T,
				KEY_U = KEY_INPUT_U,
				KEY_V = KEY_INPUT_V,
				KEY_W = KEY_INPUT_W,
				KEY_X = KEY_INPUT_X,
				KEY_Y = KEY_INPUT_Y,
				KEY_Z = KEY_INPUT_Z,
				KEY_0 = KEY_INPUT_0,
				KEY_1 = KEY_INPUT_1,
				KEY_2 = KEY_INPUT_2,
				KEY_3 = KEY_INPUT_3,
				KEY_4 = KEY_INPUT_4,
				KEY_5 = KEY_INPUT_5,
				KEY_6 = KEY_INPUT_6,
				KEY_7 = KEY_INPUT_7,
				KEY_8 = KEY_INPUT_8,
				KEY_9 = KEY_INPUT_9
			};
			Keyboard();
			~Keyboard();
			void updata();
			bool isOn( Key key ) const;
			bool isDown( Key key ) const;
		private:
			int mIndex;
			char* mStates[ 10 ];
			//boost::circular_buffer< char* > mStates;
		};
	}
}