#include "Manager.h"
#include "Pad.h"
#include "Mouse.h"
#include "Keyboard.h"
#include <DxLib.h>
namespace FTLib{
	namespace Input{
		void Manager::init(){
			if( mPads->size() == 0 ){
				int num = GetJoypadNum();
				if( num == 0 ){
					num = 1;
				}
				for( int i = 0 ; i < num ; ++i ){
					mPads->push_back( new Pad( i ) );
				}
			}
			if( mMouse == 0 ){
				mMouse = new Mouse();
			}
			if( mKeyboard == 0 ){
				mKeyboard = new Keyboard();
			}
		}
		void Manager::updata(){
			for( int i = mPads->size() ; i > 0 ; --i ){
				mPads->at( i - 1 )->updata();
			}
			mMouse->updata();
			mKeyboard->updata();
		}
		int Manager::joypadNum() const{
			return GetJoypadNum();
		}
		Pad* Manager::getPad( int n ) const{
			return mPads->at( n );
		}
		Mouse* Manager::getMouse() const{
			return mMouse;
		}
		Keyboard* Manager::getKeyboard() const{
			return mKeyboard;
		}
		void Manager::create(){
			if( !mInstance ){
				mInstance = new Manager();
			}
		}
		void Manager::destroy(){
			if( mInstance ){
				delete mInstance;
				mInstance = 0;
			}
		}
		Manager* Manager::instance(){
			return mInstance;
		}
		Manager::Manager() : 
		mMouse( 0 ),
		mKeyboard( 0 ){
			mPads = new std::vector< Pad* >();
		}
		Manager::~Manager(){
			mPads->clear();
			delete mPads;
		}
		Manager* Manager::mInstance = 0;
	}
}