#include "Mouse.h"
namespace FTLib{
	namespace Input{
		Mouse::Mouse(){
			mButtonStates = new boost::circular_buffer< int >( 10 );
		}
		Mouse::~Mouse(){
			delete mButtonStates;
		}
		void Mouse::updata(){
			mButtonStates->push_front( GetMouseInput() );
			int x = mPos.x;
			int y = mPos.y;
			GetMousePoint( &x , &y );
			mPos.x = x;
			mPos.y = y;
		}
		Vector Mouse::getPos(){
			return mPos;
		}
		void Mouse::setPos( Vector pos ){
			SetMousePoint( pos.x , pos.y );
			mPos = pos;
		}
		bool Mouse::isOn( Mouse::Button b ){
			if( mButtonStates->size() == 0 ){
				return false;
			}
			if( mButtonStates->at( 0 ) & b ){
				return true;
			}else{
				return false;
			}
		}
		bool Mouse::isDown( Mouse::Button b ){
			if( mButtonStates->size() < 2 ){
				return false;
			}
			if( ( mButtonStates->at( 0 ) & b ) &&
				( ! ( mButtonStates->at( 1 ) & b ) ) ){
					return true;
			}else{
				return false;
			}
		}
		bool Mouse::isDownDouble( Mouse::Button b ){
			if( mButtonStates->size() < 8 ){
				return false;
			}
			if( ( mButtonStates->at( 0 ) & b ) &&
				( ! ( mButtonStates->at( 1 ) & b ) ) ){
					for( int i = 0 ; i < 4 ; ++ i ){
						if( mButtonStates->at( i + 2 ) & b ){
							return true;
						}
					}
					return false;
			}else{
				return false;
			}
		}
	}
}