#pragma once
#include <boost/circular_buffer.hpp>
#include <DxLib.h>
namespace FTLib{
	namespace Draw{
		typedef VECTOR Vector;
	}
	using namespace FTLib::Draw;
	namespace Input{
		class Pad{
		public:
			enum Button{
				BUT_UP = PAD_INPUT_UP,
				BUT_DOWN = PAD_INPUT_DOWN,
				BUT_LEFT = PAD_INPUT_LEFT,
				BUT_RIGHT = PAD_INPUT_RIGHT,
				BUT_A = PAD_INPUT_A,
				BUT_B = PAD_INPUT_B,
				BUT_X = PAD_INPUT_C,
				BUT_Y = PAD_INPUT_X,
				BUT_LB = PAD_INPUT_Y,
				BUT_RB = PAD_INPUT_Z,
				BUT_BACK = PAD_INPUT_L,
				BUT_START = PAD_INPUT_R
			};
			enum Axis{
				AXIS_UP,
				AXIS_DOWN,
				AXIS_LEFT,
				AXIS_RIGHT
			};
			Pad( int n );
			~Pad();
			void updata();
			bool isOn( Button b ) const;
			bool isDown( Button b ) const;
			Vector joypadAxis() const;
			Vector joypadAxisRight() const;
			bool isDownAxis( Axis axis ) const;
			bool isDownAxisRight( Axis axis ) const;
		private:
			Vector mUpdataAxis();
			Vector mUpdataRightAxis();
			int mNum;
			boost::circular_buffer< int >* mStates;
			boost::circular_buffer< Vector >* mAxisStates;
			boost::circular_buffer< Vector >* mRightAxisStates;
		};
	}
}