#pragma once
#include "Std.h"
class MainMenu : public ISequence{
public:
	MainMenu(){ Init(); }
	~MainMenu(){}
	void Init(){
		mKeyboard = Manager::instance()->getKeyboard();
		mPad = Manager::instance()->getPad( 0 );
		mPointer = SEL_Start;
		mBg = shared_ptr< Image >( new Image( "Pict/MainMenu/Bg.png" ) );
		mStart = shared_ptr< Image >( new Image( "Pict/MainMenu/Start.png" ) );
		mStart_OnCursor = shared_ptr< Image >( new Image( "Pict/MainMenu/OnStart.png" ) );
		mQuit = shared_ptr< Image >( new Image( "Pict/MainMenu/Quit.png" ) );
		mQuit_OnCursor = shared_ptr< Image >( new Image( "Pict/MainMenu/OnQuit.png" ) );
	}
	void OnUpdate( IrisBaseGame* mGame , unsigned int elpsedFrame ){
		if( ( mKeyboard->isDown( Keyboard::KEY_UP ) ||
			mPad->isDown( Pad::BUT_UP ) ) &&
			mPointer == SEL_Quit ){
				mPointer = SEL_Start;
		}else if( ( mKeyboard->isDown( Keyboard::KEY_DOWN ) ||
			mPad->isDown( Pad::BUT_DOWN ) ) &&
			mPointer == SEL_Start ){
				mPointer = SEL_Quit;
		}else if( mKeyboard->isDown( Keyboard::KEY_Z ) ||
			mPad->isDown( Pad::BUT_A ) ){
				switch( mPointer ){
					case SEL_Start:
						mGame->SequenceMove( SEQ_Loading );
						break;
					case SEL_Quit:
						mGame->SequenceMove( SEQ_Quit );
				}
		}
		mBg->draw( 0 , 0 );
		mStart->draw( 54 , 320 );
		mQuit->draw( 54 , 320 + mStart->height() );
		switch( mPointer ){
			case SEL_Start:
				mStart_OnCursor->draw( 54 , 320 );
				break;
			case SEL_Quit:
				mQuit_OnCursor->draw( 54 , 320 + mStart_OnCursor->height() );
				break;
		}
	}
private:
	enum Select{
		SEL_Start,
		SEL_Quit
	};
	Select mPointer;
	shared_ptr< Image > mStart;
	shared_ptr< Image > mStart_OnCursor;
	shared_ptr< Image > mQuit;
	shared_ptr< Image > mQuit_OnCursor;
	shared_ptr< Image > mBg;
	Keyboard* mKeyboard;
	Pad* mPad;
};