#include "ShotMovePattern.h"
#include "Game.h"
#include "Actors.h"
ShotPicts* gShotPicts = 0;
SoundDatas* gSoundDatas = 0;
void SM_StraightToP::OnUpdate( Game* game , IActor* enemy ){
	if( mEndTime % mFreq == 0 ){
		Math::Vector playerPos = game->GetPlayer()->VGetPos();
		float x = playerPos.x - enemy->VGetPos().x;
		float y = playerPos.y - enemy->VGetPos().y;
		float angle = atan2f( y , x );
		shared_ptr< StraightShot > shot( new StraightShot( enemy , angle , mSpeed ) );
		game->AddEnemyShot( shot );
	}
	if( mIsEndless ){
		++mEndTime;
	}else if( mEndTime > 0 ){
		--mEndTime;
	}
}
void SM_StraightToFirstPos::OnUpdate( Game* game , IActor* enemy ){
	if( !mIsInit ){
		mPoint = game->GetPlayer()->VGetPos();
		mIsInit = true;
	}
	if( mEndTime % mFreq == 0 ){
		float x = mPoint.x - enemy->VGetPos().x;
		float y = mPoint.y - enemy->VGetPos().y;
		float angle = atan2f( x , y );
		shared_ptr< StraightShot > shot( new StraightShot( enemy , angle , mSpeed ) );
		game->AddEnemyShot( shot );
	}
	if( mIsEndless ){
		++mEndTime;
	}else if( mEndTime > 0 ){
		--mEndTime;
	}
}
void SM_StrAcceToP::OnUpdate( Game* game , IActor* enemy ){
	if( mEndTime % mFreq == 0 ){
		Math::Vector playerPos = game->GetPlayer()->VGetPos();
		float x = playerPos.x - enemy->VGetPos().x;
		float y = playerPos.y - enemy->VGetPos().y;
		float angle = atan2f( y , x );
		shared_ptr< TransShot > shot( new TransShot( enemy , angle , mSpeed , mAcce ) );
		game->AddEnemyShot( shot );
	}
	if( mIsEndless ){
		++mEndTime;
	}else if( mEndTime > 0 ){
		--mEndTime;
	}
}
void SM_StrDeceToP::OnUpdate( Game* game , IActor* enemy ){
	if( mEndTime % mFreq == 0 ){
		Math::Vector playerPos = game->GetPlayer()->VGetPos();
		float x = playerPos.x - enemy->VGetPos().x;
		float y = playerPos.y - enemy->VGetPos().y;
		float angle = atan2f( y , x );
		shared_ptr< TransShot > shot( new TransShot( enemy , angle , mSpeed , -mDece ) );
		game->AddEnemyShot( shot );
	}
	if( mIsEndless ){
		++mEndTime;
	}else if( mEndTime > 0 ){
		--mEndTime;
	}
}
void SM_Circle::OnUpdate( Game* game , IActor* enemy ){
	if( mEndTime % mFreq == 0 ){
		float angle = 0.0f;
		for( int i = 0 ; i < mNum ; ++i ){
			angle += Math::degeeToRad( 360.0f / mNum );
			shared_ptr< StraightShot > shot( new StraightShot( enemy , angle , mSpeed ) );
			game->AddEnemyShot( shot );
		}
	}
	if( mIsEndless ){
		++mEndTime;
	}else if( mEndTime > 0 ){
		--mEndTime;
	}
}
void SM_Random::OnUpdate( Game* game , IActor* enemy ){
	if( mEndTime % mFreq == 0 ){
		for( int i = 0 ; i < mNum ; ++i ){
			float angle = Math::degeeToRad( gApp->GetRandom( 0 , 360 ) );
			shared_ptr< StraightShot > shot( new StraightShot( enemy , angle , mSpeed ) );
			game->AddEnemyShot( shot );
		}
	}
	if( mIsEndless ){
		++mEndTime;
	}else if( mEndTime > 0 ){
		--mEndTime;
	}
}
void SM_RandomAcce::OnUpdate( Game* game , IActor* enemy ){
	if( mEndTime % mFreq == 0 ){
		for( int i = 0 ; i < mNum ; ++i ){
			float angle = Math::degeeToRad( gApp->GetRandom( 0 , 360 ) );
			shared_ptr< TransShot > shot( new TransShot( enemy , angle , mSpeed , mAcce ) );
			game->AddEnemyShot( shot );
		}
	}
	if( mIsEndless ){
		++mEndTime;
	}else if( mEndTime > 0 ){
		--mEndTime;
	}
}
void SM_RandomDece::OnUpdate( Game* game , IActor* enemy ){
	if( mEndTime % mFreq == 0 ){
		for( int i = 0 ; i < mNum ; ++i ){
			float angle = Math::degeeToRad( gApp->GetRandom( 0 , 360 ) );
			shared_ptr< TransShot > shot( new TransShot( enemy , angle , mSpeed , -mDece ) );
			game->AddEnemyShot( shot );
		}
	}
	if( mIsEndless ){
		++mEndTime;
	}else if( mEndTime > 0 ){
		--mEndTime;
	}
}
void SM_Ereka::OnUpdate( Game* game, IActor* enemy ){
	if( mCnt % 10 == 0 ){
		for( int i = 0 ; i < 5 ; ++i ){
			shared_ptr< StraightShot > strShot( new StraightShot( enemy , Math::degeeToRad( 360.0f / 5.0f * i + mCnt % 721 / 2.0f ) , 2 ) );
			game->AddEnemyShot( strShot );
		}
	}
	if( mCnt % 45 == 0 ){
		if( mCircleCnt >= 0 ){
			int MAX_RING = 36;
			Math::Vector Center;
			float centerX = enemy->VGetPos().x + cosf( Math::degeeToRad( 360 / 5 * mCircleCnt + 54 ) ) * 70;
			float centerY = enemy->VGetPos().y + sinf( Math::degeeToRad( 360 / 5 * mCircleCnt  + 54 ) ) * 70;
			for( int j = 0 ; j < MAX_RING ; j++ ){
				float x = centerX + cosf( Math::degeeToRad( 360 / MAX_RING * j ) ) * 30;
				float y = centerY + sinf( Math::degeeToRad( 360 / MAX_RING * j ) ) * 30;
				shared_ptr< DelayStraightShot > delayShot( new DelayStraightShot( enemy , 270 - mCircleCnt * 45 , 3.0f , Math::degeeToRad( 360 / MAX_RING * j ) , Math::getVector( x , y , 0 ) ) );
				game->AddEnemyShot( delayShot );
			}
		}
		++mCircleCnt;
		if( mCircleCnt == 5 ){
			mCircleCnt = -2;
		}
	}
	if( mLineCnt == 0 ){
	}
	switch( mMode ){
		case EREK_LineInit:
			mLinePos[ 0 ] = Math::getVector( 0 , 100 , 0 );
			mLinePos[ 1 ] = Math::getVector( 450 , 100 , 0 );
			mLinePos[ 2 ] = Math::getVector( 0 , 300 , 0 );
			mLinePos[ 3 ] = Math::getVector( 450 , 300 , 0 );
			mLineAngle[ 0 ] = Math::degeeToRad( 20 );
			mLineAngle[ 1 ] = Math::degeeToRad( 160 );
			mLineAngle[ 2 ] = Math::degeeToRad( 340 );
			mLineAngle[ 3 ] = Math::degeeToRad( 200 );
			mMode = EREK_Line;
			mLineCnt = 0;
			mMode = EREK_Line;
			break;
		case EREK_Line:
			if( mCnt % 2 == 0 ){
				for( int i = 0 ; i < 4 ; ++i ){
					mLinePos[ i ].x += cosf( mLineAngle[ i ] ) * 20.0f;
					mLinePos[ i ].y += sinf( mLineAngle[ i ] ) * 20.0f;
					shared_ptr< ErekaLineShot > shot( new ErekaLineShot( enemy , 100 + 50 * i - mLineCnt * 2 , 4 , mLinePos[ i ] ) );
					game->AddEnemyShot( shot );
				}
				++mLineCnt;
				if( mLineCnt >= 200 ){
					mMode = EREK_LineInit;
				}
			}
			break;
	}
	++mCnt;
}