#include "Std.h"
#include "Opening.h"
#include "MainMenu.h"
#include "NowLoading.h"
#include "Game.h"
#include "Actors.h"
IrisBaseGame::IrisBaseGame(){
	mSequence = shared_ptr< ISequence >( new Opening() );
	mNext = SEQ_None;
	mLastActorID = 0;
}
bool IrisBaseGame::OnUpdate( unsigned int elapsedFrame ){
	mSequence->OnUpdate( this , elapsedFrame );
	switch( mNext ){
		case SEQ_Init:
		case SEQ_Opening:
			mSequence = shared_ptr< ISequence >( new Opening() );
			break;
		case SEQ_MainMenu:
			mSequence = shared_ptr< ISequence >( new MainMenu() );
			break;
		case SEQ_Loading:
			mSequence = shared_ptr< ISequence >( new NowLoading() );
			break;
		case SEQ_Game:
			mSequence.reset();
			mSequence = shared_ptr< ISequence >( new Game() );
			break;
		case SEQ_Quit:
			return true;
	}
	mNext = SEQ_None;
	return false;
}
GameApp* gApp = 0;